<html>
<head>
<title>Ogre::NumericAnimationTrack Class Reference - OGRE Documentation</title> <meta http-equiv="Content-Type" content="text/html; charset=iso-8859-1"> 
<link type="text/css" rel="stylesheet" href="doxygen.css">
<link type="text/css" rel="stylesheet" href="tabs.css">
</head>

<body>
<!-- Generated by Doxygen 1.7.6.1 -->
  <div id="navrow1" class="tabs">
    <ul class="tablist">
      <li><a href="index.html"><span>Main&#160;Page</span></a></li>
      <li><a href="pages.html"><span>Related&#160;Pages</span></a></li>
      <li><a href="modules.html"><span>Modules</span></a></li>
      <li><a href="namespaces.html"><span>Namespaces</span></a></li>
      <li class="current"><a href="annotated.html"><span>Classes</span></a></li>
      <li><a href="files.html"><span>Files</span></a></li>
      <li><a href="dirs.html"><span>Directories</span></a></li>
    </ul>
  </div>
  <div id="navrow2" class="tabs2">
    <ul class="tablist">
      <li><a href="annotated.html"><span>Class&#160;List</span></a></li>
      <li><a href="classes.html"><span>Class&#160;Index</span></a></li>
      <li><a href="inherits.html"><span>Class&#160;Hierarchy</span></a></li>
      <li><a href="functions.html"><span>Class&#160;Members</span></a></li>
    </ul>
  </div>
  <div id="nav-path" class="navpath">
    <ul>
      <li class="navelem"><a class="el" href="namespaceOgre.html">Ogre</a>      </li>
      <li class="navelem"><a class="el" href="classOgre_1_1NumericAnimationTrack.html">NumericAnimationTrack</a>      </li>
    </ul>
  </div>
</div>
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pro-types">Protected Types</a> &#124;
<a href="#pro-methods">Protected Member Functions</a> &#124;
<a href="#pro-attribs">Protected Attributes</a>  </div>
  <div class="headertitle">
<div class="title">Ogre::NumericAnimationTrack Class Reference<div class="ingroups"><a class="el" href="group__Animation.html">Animation</a></div></div>  </div>
</div><!--header-->
<div class="contents">
<!-- doxytag: class="Ogre::NumericAnimationTrack" --><!-- doxytag: inherits="Ogre::AnimationTrack" -->
<p>Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a> for dealing with generic animable values.  
 <a href="classOgre_1_1NumericAnimationTrack.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>&gt;</code></p>
<div class="dynheader">
Inheritance diagram for Ogre::NumericAnimationTrack:</div>
<div class="dyncontent">
<div class="center"><img src="classOgre_1_1NumericAnimationTrack__inherit__graph.gif" border="0" usemap="#Ogre_1_1NumericAnimationTrack_inherit__map" alt="Inheritance graph"/></div>
<map name="Ogre_1_1NumericAnimationTrack_inherit__map" id="Ogre_1_1NumericAnimationTrack_inherit__map">
<area shape="rect" id="node2" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e." alt="" coords="29,83,179,112"/><area shape="rect" id="node4" href="classOgre_1_1AllocatedObject.html" title="Superclass for all objects that wish to use custom memory allocators when their new / delete operator..." alt="" coords="49,5,159,35"/></map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>

<p><a href="classOgre_1_1NumericAnimationTrack-members.html">List of all members.</a></p>
<table class="memberdecls">
<tr><td colspan="2"><h2><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a2abae8df7bf7a90ec35cb57a8a412e38">NumericAnimationTrack</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *parent, unsigned short handle)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor.  <a href="#a2abae8df7bf7a90ec35cb57a8a412e38"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a85e2b687e0e4952736ee02de3d53bc43">NumericAnimationTrack</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *parent, unsigned short handle, <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> &amp;target)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Constructor, associates with an <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, i.e.">AnimableValue</a>.  <a href="#a85e2b687e0e4952736ee02de3d53bc43"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#ad1c0346a522eed44ee1fcb849e27897e">createNumericKeyFrame</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timePos)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index.  <a href="#ad1c0346a522eed44ee1fcb849e27897e"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#aaa8109fd7c326e9d4c98c0187896e6da">getInterpolatedKeyFrame</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *kf) const </td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#aadd219663715ff7f2f74b7255ebcbae4">apply</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> weight=1.0, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> scale=1.0f)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a2e9aaebae7953605d698f9c6f4ceb6e5">applyToAnimable</a> (const <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> &amp;anim, const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> weight=1.0, <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> scale=1.0f)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Applies an animation track to a given animable value.  <a href="#a2e9aaebae7953605d698f9c6f4ceb6e5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual const <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a73eb9735e4dbe9370cb8689644d9a33c">getAssociatedAnimable</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns a pointer to the associated animable object (if any).  <a href="#a73eb9735e4dbe9370cb8689644d9a33c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a89d5b800fa465b59a38ab08ebee07b5a">setAssociatedAnimable</a> (const <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> &amp;val)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Sets the associated animable object which will be automatically affected by calls to 'apply'.  <a href="#a89d5b800fa465b59a38ab08ebee07b5a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#aeab662312afde85ea91bae69c35bbad5">getNumericKeyFrame</a> (unsigned short index) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index.  <a href="#aeab662312afde85ea91bae69c35bbad5"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1NumericAnimationTrack.html">NumericAnimationTrack</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#abbb4ea6a49e00abec1abb65ee4704674">_clone</a> (<a class="el" href="classOgre_1_1Animation.html">Animation</a> *newParent) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Clone this track (internal use only)  <a href="#abbb4ea6a49e00abec1abb65ee4704674"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a32de796f12f6afee4c93e12625535577">getHandle</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the handle associated with this track.  <a href="#a32de796f12f6afee4c93e12625535577"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#ae0c1160b89c7f2be74ae2962239bd732">getNumKeyFrames</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the number of keyframes in this animation.  <a href="#ae0c1160b89c7f2be74ae2962239bd732"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#af27f57a984619052cca4726cdfd26f3c">getKeyFrame</a> (unsigned short index) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index.  <a href="#af27f57a984619052cca4726cdfd26f3c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a55533ed5218c6d423e9443afa2580f5a">getKeyFramesAtTime</a> (const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;timeIndex, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **keyFrame1, <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **keyFrame2, unsigned short *firstKeyIndex=0) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Gets the 2 <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects which are active at the time given, and the blend value between them.  <a href="#a55533ed5218c6d423e9443afa2580f5a"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a4517a1b16d6cb601754d98841bb4d7d6">createKeyFrame</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> timePos)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index.  <a href="#a4517a1b16d6cb601754d98841bb4d7d6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a3e1ccd99179d804992a5224fe811c2dd">removeKeyFrame</a> (unsigned short index)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> by it's index.  <a href="#a3e1ccd99179d804992a5224fe811c2dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#ac8f7b83d742998ed46c8cdb10e404df6">removeAllKeyFrames</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Removes all the KeyFrames from this track.  <a href="#ac8f7b83d742998ed46c8cdb10e404df6"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a715b6d025247c4857a5deba9376ae48c">_keyFrameDataChanged</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data.  <a href="#a715b6d025247c4857a5deba9376ae48c"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a3a07b2082c15608cc24be21e2b6bb822">hasNonZeroKeyFrames</a> (void) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out.  <a href="#a3a07b2082c15608cc24be21e2b6bb822"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#ad96281be1b189c69a1dbd2283d583503">optimise</a> (void)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Optimise the current track by removing any duplicate keyframes.  <a href="#ad96281be1b189c69a1dbd2283d583503"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a9e950713ebb7b1c51fdd90ec8378c2cc">_collectKeyFrameTimes</a> (<a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt;::type &amp;keyFrameTimes)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method to collect keyframe times, in unique, ordered format.  <a href="#a9e950713ebb7b1c51fdd90ec8378c2cc"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#af25294adccef1ab3c5d456aee2c5cb29">_buildKeyFrameIndexMap</a> (const <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt;::type &amp;keyFrameTimes)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method to build keyframe time index map to translate global lower bound index to local lower bound index.  <a href="#af25294adccef1ab3c5d456aee2c5cb29"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#aed855e8117300af01d646ff49b020916">_applyBaseKeyFrame</a> (const <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *base)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method to re-base the keyframes relative to a given keyframe.  <a href="#aed855e8117300af01d646ff49b020916"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#afe26aa738aca34c07407b6566b5d9eeb">setListener</a> (<a class="el" href="classOgre_1_1AnimationTrack_1_1Listener.html">Listener</a> *l)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Set a listener for this track.  <a href="#afe26aa738aca34c07407b6566b5d9eeb"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a2e5269293886cae1d0bc7e0255b239fd">getParent</a> () const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Returns the parent <a class="el" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a> object for this track.  <a href="#a2e5269293886cae1d0bc7e0255b239fd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a421b197ca3a38da17e2eb1531a645fa2">operator new</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">operator new, with debug line info  <a href="#a421b197ca3a38da17e2eb1531a645fa2"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ac4bdf968b7b9af8a5239a27da73d5711">operator new</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#ab78a921e54419be677839cdf15d1f0b8">operator new</a> (size_t sz, void *ptr)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">placement operator new  <a href="#ab78a921e54419be677839cdf15d1f0b8"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a4be37baef81876985aa1071ad5acc6dd">operator new[]</a> (size_t sz, const char *file, int line, const char *func)</td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">array operator new, with debug line info  <a href="#a4be37baef81876985aa1071ad5acc6dd"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#afa2943846ba6a2b5824a12857139cf5e">operator new[]</a> (size_t sz)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a8357fe4fb4849772b94baa4bf47c7ded">operator delete</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a1c727e879a260c37b00ce5505fe8e144">operator delete</a> (void *ptr, void *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#acb46d4b0a597156d9ba5abc39d127792">operator delete</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a93e6a86dde5483c053ca0f2a85bbfd6c">operator delete[]</a> (void *ptr)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AllocatedObject.html#a595ea4c05da8aa987d3800e65d23355d">operator delete[]</a> (void *ptr, const char *, int, const char *)</td></tr>
<tr><td colspan="2"><h2><a name="pro-types"></a>
Protected Types</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> * &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#affbdca5aaf89d6d611d8da2dc6143f1a">KeyFrameList</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a> &gt;::type&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a2faf6bb4a4d61446bc25795f8f7d957c">KeyFrameIndexMap</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Map used to translate global keyframe time lower bound index to local lower bound index.  <a href="#a2faf6bb4a4d61446bc25795f8f7d957c"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-methods"></a>
Protected Member Functions</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a68c6edea0b9363bb381669d246879141">createKeyFrameImpl</a> (<a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> time)</td></tr>
<tr><td class="memItemLeft" align="right" valign="top">virtual void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a4e61fb2e00abd26a854d122452cb21a0">populateClone</a> (<a class="el" href="classOgre_1_1AnimationTrack.html">AnimationTrack</a> *clone) const </td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Internal method for clone implementation.  <a href="#a4e61fb2e00abd26a854d122452cb21a0"></a><br/></td></tr>
<tr><td colspan="2"><h2><a name="pro-attribs"></a>
Protected Attributes</h2></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a9abd089b3278141471254455f45c648d">mTargetAnim</a></td></tr>
<tr><td class="mdescLeft">&#160;</td><td class="mdescRight">Target to animate.  <a href="#a9abd089b3278141471254455f45c648d"></a><br/></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1AnimationTrack.html#affbdca5aaf89d6d611d8da2dc6143f1a">KeyFrameList</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a8a9bee08f6fa537fc0bcfcee2423775c">mKeyFrames</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#aea479089005d263e195cde7e4faca665">mParent</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top">unsigned short&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a5fb5dc3c01452aa4d542981485d15080">mHandle</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1AnimationTrack_1_1Listener.html">Listener</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#ab1a098b88d428931e3d45393410bc68c">mListener</a></td></tr>
<tr><td class="memItemLeft" align="right" valign="top"><a class="el" href="classOgre_1_1AnimationTrack.html#a2faf6bb4a4d61446bc25795f8f7d957c">KeyFrameIndexMap</a>&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classOgre_1_1AnimationTrack.html#a2c053bac1d2eedc782eb24b79dc79a21">mKeyFrameIndexMap</a></td></tr>
</table>
<hr/><a name="details" id="details"></a><h2>Detailed Description</h2>
<div class="textblock"><p>Specialised <a class="el" href="classOgre_1_1AnimationTrack.html" title="A &#39;track&#39; in an animation sequence, i.e.">AnimationTrack</a> for dealing with generic animable values. </p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00264">264</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>
</div><hr/><h2>Member Typedef Documentation</h2>
<a class="anchor" id="a2faf6bb4a4d61446bc25795f8f7d957c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::KeyFrameIndexMap" ref="a2faf6bb4a4d61446bc25795f8f7d957c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="namespaceOgre.html#af851e71354d841df7138f9877c6f5931">ushort</a>&gt;::type <a class="el" href="classOgre_1_1AnimationTrack.html#a2faf6bb4a4d61446bc25795f8f7d957c">Ogre::AnimationTrack::KeyFrameIndexMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Map used to translate global keyframe time lower bound index to local lower bound index. </p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00249">249</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="affbdca5aaf89d6d611d8da2dc6143f1a"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::KeyFrameList" ref="affbdca5aaf89d6d611d8da2dc6143f1a" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">typedef <a class="el" href="structOgre_1_1vector.html">vector</a>&lt;<a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>*&gt;::type <a class="el" href="classOgre_1_1AnimationTrack.html#affbdca5aaf89d6d611d8da2dc6143f1a">Ogre::AnimationTrack::KeyFrameList</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00242">242</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<hr/><h2>Constructor &amp; Destructor Documentation</h2>
<a class="anchor" id="a2abae8df7bf7a90ec35cb57a8a412e38"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::NumericAnimationTrack" ref="a2abae8df7bf7a90ec35cb57a8a412e38" args="(Animation *parent, unsigned short handle)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a2abae8df7bf7a90ec35cb57a8a412e38">Ogre::NumericAnimationTrack::NumericAnimationTrack</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&#160;</td>
          <td class="paramname"><em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>handle</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructor. </p>

</div>
</div>
<a class="anchor" id="a85e2b687e0e4952736ee02de3d53bc43"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::NumericAnimationTrack" ref="a85e2b687e0e4952736ee02de3d53bc43" args="(Animation *parent, unsigned short handle, AnimableValuePtr &amp;target)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1NumericAnimationTrack.html#a2abae8df7bf7a90ec35cb57a8a412e38">Ogre::NumericAnimationTrack::NumericAnimationTrack</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&#160;</td>
          <td class="paramname"><em>parent</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>handle</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> &amp;&#160;</td>
          <td class="paramname"><em>target</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Constructor, associates with an <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, i.e.">AnimableValue</a>. </p>

</div>
</div>
<hr/><h2>Member Function Documentation</h2>
<a class="anchor" id="aed855e8117300af01d646ff49b020916"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_applyBaseKeyFrame" ref="aed855e8117300af01d646ff49b020916" args="(const KeyFrame *base)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#aed855e8117300af01d646ff49b020916">Ogre::AnimationTrack::_applyBaseKeyFrame</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&#160;</td>
          <td class="paramname"><em>base</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method to re-base the keyframes relative to a given keyframe. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1VertexAnimationTrack.html#a6a2e377adc0c21f46907ac73553c2024">Ogre::VertexAnimationTrack</a>, and <a class="el" href="classOgre_1_1NodeAnimationTrack.html#acdfc6729a95edae3da832c713648046d">Ogre::NodeAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00234">234</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="af25294adccef1ab3c5d456aee2c5cb29"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_buildKeyFrameIndexMap" ref="af25294adccef1ab3c5d456aee2c5cb29" args="(const vector&lt; Real &gt;::type &amp;keyFrameTimes)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#af25294adccef1ab3c5d456aee2c5cb29">Ogre::AnimationTrack::_buildKeyFrameIndexMap</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt;::type &amp;&#160;</td>
          <td class="paramname"><em>keyFrameTimes</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method to build keyframe time index map to translate global lower bound index to local lower bound index. </p>

</div>
</div>
<a class="anchor" id="abbb4ea6a49e00abec1abb65ee4704674"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_clone" ref="abbb4ea6a49e00abec1abb65ee4704674" args="(Animation *newParent) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1NumericAnimationTrack.html">NumericAnimationTrack</a>* <a class="el" href="classOgre_1_1NumericAnimationTrack.html#abbb4ea6a49e00abec1abb65ee4704674">Ogre::NumericAnimationTrack::_clone</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1Animation.html">Animation</a> *&#160;</td>
          <td class="paramname"><em>newParent</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Clone this track (internal use only) </p>

</div>
</div>
<a class="anchor" id="a9e950713ebb7b1c51fdd90ec8378c2cc"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_collectKeyFrameTimes" ref="a9e950713ebb7b1c51fdd90ec8378c2cc" args="(vector&lt; Real &gt;::type &amp;keyFrameTimes)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#a9e950713ebb7b1c51fdd90ec8378c2cc">Ogre::AnimationTrack::_collectKeyFrameTimes</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="structOgre_1_1vector.html">vector</a>&lt; <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> &gt;::type &amp;&#160;</td>
          <td class="paramname"><em>keyFrameTimes</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method to collect keyframe times, in unique, ordered format. </p>

</div>
</div>
<a class="anchor" id="a715b6d025247c4857a5deba9376ae48c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::_keyFrameDataChanged" ref="a715b6d025247c4857a5deba9376ae48c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#a715b6d025247c4857a5deba9376ae48c">Ogre::AnimationTrack::_keyFrameDataChanged</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method used to tell the track that keyframe data has been changed, which may cause it to rebuild some internal data. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1NodeAnimationTrack.html#ac63ec3b7f27897f2223aca60f4c90422">Ogre::NodeAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00215">215</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="aadd219663715ff7f2f74b7255ebcbae4"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::apply" ref="aadd219663715ff7f2f74b7255ebcbae4" args="(const TimeIndex &amp;timeIndex, Real weight=1.0, Real scale=1.0f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1NumericAnimationTrack.html#aadd219663715ff7f2f74b7255ebcbae4">Ogre::NumericAnimationTrack::apply</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&#160;</td>
          <td class="paramname"><em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>weight</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>scale</em> = <code>1.0f</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Applies an animation track to the designated target. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">timeIndex</td><td>The time position in the animation to apply. </td></tr>
    <tr><td class="paramname">weight</td><td>The influence to give to this track, 1.0 for full influence, less to blend with other animations. </td></tr>
    <tr><td class="paramname">scale</td><td>The scale to apply to translations and scalings, useful for adapting an animation to a different size target. </td></tr>
  </table>
  </dd>
</dl>
 
<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#aa32b2807aee58478f96e75bfa44141cc">Ogre::AnimationTrack</a>.</p>

</div>
</div>
<a class="anchor" id="a2e9aaebae7953605d698f9c6f4ceb6e5"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::applyToAnimable" ref="a2e9aaebae7953605d698f9c6f4ceb6e5" args="(const AnimableValuePtr &amp;anim, const TimeIndex &amp;timeIndex, Real weight=1.0, Real scale=1.0f)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1NumericAnimationTrack.html#a2e9aaebae7953605d698f9c6f4ceb6e5">Ogre::NumericAnimationTrack::applyToAnimable</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> &amp;&#160;</td>
          <td class="paramname"><em>anim</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&#160;</td>
          <td class="paramname"><em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>weight</em> = <code>1.0</code>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>scale</em> = <code>1.0f</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Applies an animation track to a given animable value. </p>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">anim</td><td>The <a class="el" href="classOgre_1_1AnimableValue.html" title="Defines an object property which is animable, i.e.">AnimableValue</a> to which to apply the animation </td></tr>
    <tr><td class="paramname">timeIndex</td><td>The time position in the animation to apply. </td></tr>
    <tr><td class="paramname">weight</td><td>The influence to give to this track, 1.0 for full influence, less to blend with other animations. </td></tr>
    <tr><td class="paramname">scale</td><td>The scale to apply to translations and scalings, useful for adapting an animation to a different size target. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a4517a1b16d6cb601754d98841bb4d7d6"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::createKeyFrame" ref="a4517a1b16d6cb601754d98841bb4d7d6" args="(Real timePos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* <a class="el" href="classOgre_1_1AnimationTrack.html#a4517a1b16d6cb601754d98841bb4d7d6">Ogre::AnimationTrack::createKeyFrame</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>timePos</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0); </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">timePos</td><td>The time from which this <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> will apply. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a68c6edea0b9363bb381669d246879141"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::createKeyFrameImpl" ref="a68c6edea0b9363bb381669d246879141" args="(Real time)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* <a class="el" href="classOgre_1_1NumericAnimationTrack.html#a68c6edea0b9363bb381669d246879141">Ogre::NumericAnimationTrack::createKeyFrameImpl</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>time</em></td><td>)</td>
          <td><code> [protected, virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Create a keyframe implementation - must be overridden. </p>
 
<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#aa344f22d2582a0adacea56bf7b6dcd7d">Ogre::AnimationTrack</a>.</p>

</div>
</div>
<a class="anchor" id="ad1c0346a522eed44ee1fcb849e27897e"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::createNumericKeyFrame" ref="ad1c0346a522eed44ee1fcb849e27897e" args="(Real timePos)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a>* <a class="el" href="classOgre_1_1NumericAnimationTrack.html#ad1c0346a522eed44ee1fcb849e27897e">Ogre::NumericAnimationTrack::createNumericKeyFrame</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a>&#160;</td>
          <td class="paramname"><em>timePos</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Creates a new <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> and adds it to this animation at the given time index. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>It is better to create KeyFrames in time order. Creating them out of order can result in expensive reordering processing. Note that a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at time index 0.0 is always created for you, so you don't need to create this one, just access it using getKeyFrame(0); </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">timePos</td><td>The time from which this <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> will apply. </td></tr>
  </table>
  </dd>
</dl>

</div>
</div>
<a class="anchor" id="a73eb9735e4dbe9370cb8689644d9a33c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getAssociatedAnimable" ref="a73eb9735e4dbe9370cb8689644d9a33c" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual const <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a>&amp; <a class="el" href="classOgre_1_1NumericAnimationTrack.html#a73eb9735e4dbe9370cb8689644d9a33c">Ogre::NumericAnimationTrack::getAssociatedAnimable</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns a pointer to the associated animable object (if any). </p>

</div>
</div>
<a class="anchor" id="a32de796f12f6afee4c93e12625535577"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getHandle" ref="a32de796f12f6afee4c93e12625535577" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short <a class="el" href="classOgre_1_1AnimationTrack.html#a32de796f12f6afee4c93e12625535577">Ogre::AnimationTrack::getHandle</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Get the handle associated with this track. </p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00145">145</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="aaa8109fd7c326e9d4c98c0187896e6da"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getInterpolatedKeyFrame" ref="aaa8109fd7c326e9d4c98c0187896e6da" args="(const TimeIndex &amp;timeIndex, KeyFrame *kf) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1NumericAnimationTrack.html#aaa8109fd7c326e9d4c98c0187896e6da">Ogre::NumericAnimationTrack::getInterpolatedKeyFrame</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&#160;</td>
          <td class="paramname"><em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> *&#160;</td>
          <td class="paramname"><em>kf</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">
<p>Gets a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> object which contains the interpolated transforms at the time index specified. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>The <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects held by this class are transformation snapshots at discrete points in time. Normally however, you want to interpolate between these keyframes to produce smooth movement, and this method allows you to do this easily. In animation terminology this is called 'tweening'. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">timeIndex</td><td>The time (in relation to the whole animation sequence) </td></tr>
    <tr><td class="paramname">kf</td><td>Keyframe object to store results </td></tr>
  </table>
  </dd>
</dl>
 
<p>Implements <a class="el" href="classOgre_1_1AnimationTrack.html#a48a8e96d4cb65f050dfed427f4442aa4">Ogre::AnimationTrack</a>.</p>

</div>
</div>
<a class="anchor" id="af27f57a984619052cca4726cdfd26f3c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getKeyFrame" ref="af27f57a984619052cca4726cdfd26f3c" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a>* <a class="el" href="classOgre_1_1AnimationTrack.html#af27f57a984619052cca4726cdfd26f3c">Ogre::AnimationTrack::getKeyFrame</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index. </p>

</div>
</div>
<a class="anchor" id="a55533ed5218c6d423e9443afa2580f5a"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getKeyFramesAtTime" ref="a55533ed5218c6d423e9443afa2580f5a" args="(const TimeIndex &amp;timeIndex, KeyFrame **keyFrame1, KeyFrame **keyFrame2, unsigned short *firstKeyIndex=0) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual <a class="el" href="namespaceOgre.html#aa3a7b6dfb905e6572d62f0dfa3d4274d">Real</a> <a class="el" href="classOgre_1_1AnimationTrack.html#a55533ed5218c6d423e9443afa2580f5a">Ogre::AnimationTrack::getKeyFramesAtTime</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="classOgre_1_1TimeIndex.html">TimeIndex</a> &amp;&#160;</td>
          <td class="paramname"><em>timeIndex</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **&#160;</td>
          <td class="paramname"><em>keyFrame1</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype"><a class="el" href="classOgre_1_1KeyFrame.html">KeyFrame</a> **&#160;</td>
          <td class="paramname"><em>keyFrame2</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">unsigned short *&#160;</td>
          <td class="paramname"><em>firstKeyIndex</em> = <code>0</code>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Gets the 2 <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> objects which are active at the time given, and the blend value between them. </p>
<dl class="remark"><dt><b>Remarks:</b></dt><dd>At any point in time in an animation, there are either 1 or 2 keyframes which are 'active', 1 if the time index is exactly on a keyframe, 2 at all other times i.e. the keyframe before and the keyframe after. </dd></dl>
<dl class="user"><dt><b></b></dt><dd>This method returns those keyframes given a time index, and also returns a parametric value indicating the value of 't' representing where the time index falls between them. E.g. if it returns 0, the time index is exactly on keyFrame1, if it returns 0.5 it is half way between keyFrame1 and keyFrame2 etc. </dd></dl>
<dl class="params"><dt><b>Parameters:</b></dt><dd>
  <table class="params">
    <tr><td class="paramname">timeIndex</td><td>The time index. </td></tr>
    <tr><td class="paramname">keyFrame1</td><td>Pointer to a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> pointer which will receive the pointer to the keyframe just before or at this time index. </td></tr>
    <tr><td class="paramname">keyFrame2</td><td>Pointer to a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> pointer which will receive the pointer to the keyframe just after this time index. </td></tr>
    <tr><td class="paramname">firstKeyIndex</td><td>Pointer to an unsigned short which, if supplied, will receive the index of the 'from' keyframe in case the caller needs it. </td></tr>
  </table>
  </dd>
</dl>
<dl class="return"><dt><b>Returns:</b></dt><dd>Parametric value indicating how far along the gap between the 2 keyframes the timeIndex value is, e.g. 0.0 for exactly at 1, 0.25 for a quarter etc. By definition the range of this value is: 0.0 &lt;= returnValue &lt; 1.0 . </dd></dl>

</div>
</div>
<a class="anchor" id="aeab662312afde85ea91bae69c35bbad5"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getNumericKeyFrame" ref="aeab662312afde85ea91bae69c35bbad5" args="(unsigned short index) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1NumericKeyFrame.html">NumericKeyFrame</a>* <a class="el" href="classOgre_1_1NumericAnimationTrack.html#aeab662312afde85ea91bae69c35bbad5">Ogre::NumericAnimationTrack::getNumericKeyFrame</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> at the specified index. </p>

</div>
</div>
<a class="anchor" id="ae0c1160b89c7f2be74ae2962239bd732"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getNumKeyFrames" ref="ae0c1160b89c7f2be74ae2962239bd732" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual unsigned short <a class="el" href="classOgre_1_1AnimationTrack.html#ae0c1160b89c7f2be74ae2962239bd732">Ogre::AnimationTrack::getNumKeyFrames</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the number of keyframes in this animation. </p>

</div>
</div>
<a class="anchor" id="a2e5269293886cae1d0bc7e0255b239fd"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::getParent" ref="a2e5269293886cae1d0bc7e0255b239fd" args="() const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Animation.html">Animation</a>* <a class="el" href="classOgre_1_1AnimationTrack.html#a2e5269293886cae1d0bc7e0255b239fd">Ogre::AnimationTrack::getParent</a> </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Returns the parent <a class="el" href="classOgre_1_1Animation.html" title="An animation sequence.">Animation</a> object for this track. </p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00240">240</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="a3a07b2082c15608cc24be21e2b6bb822"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::hasNonZeroKeyFrames" ref="a3a07b2082c15608cc24be21e2b6bb822" args="(void) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual bool <a class="el" href="classOgre_1_1AnimationTrack.html#a3a07b2082c15608cc24be21e2b6bb822">Ogre::AnimationTrack::hasNonZeroKeyFrames</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td> const<code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Method to determine if this track has any KeyFrames which are doing anything useful - can be used to determine if this track can be optimised out. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1VertexAnimationTrack.html#afa0e80d8dd451a65d89f7f9365a929e5">Ogre::VertexAnimationTrack</a>, and <a class="el" href="classOgre_1_1NodeAnimationTrack.html#a33dfa5ceaf4d6636da3a46038068aa11">Ogre::NodeAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00221">221</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8357fe4fb4849772b94baa4bf47c7ded"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator delete" ref="a8357fe4fb4849772b94baa4bf47c7ded" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00095">95</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a1c727e879a260c37b00ce5505fe8e144"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator delete" ref="a1c727e879a260c37b00ce5505fe8e144" args="(void *ptr, void *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00101">101</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="acb46d4b0a597156d9ba5abc39d127792"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator delete" ref="acb46d4b0a597156d9ba5abc39d127792" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00107">107</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a93e6a86dde5483c053ca0f2a85bbfd6c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator delete[]" ref="a93e6a86dde5483c053ca0f2a85bbfd6c" args="(void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00112">112</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a595ea4c05da8aa987d3800e65d23355d"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator delete[]" ref="a595ea4c05da8aa987d3800e65d23355d" args="(void *ptr, const char *, int, const char *)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator delete[] </td>
          <td>(</td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname">, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname">&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00118">118</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a421b197ca3a38da17e2eb1531a645fa2"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator new" ref="a421b197ca3a38da17e2eb1531a645fa2" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00067">67</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ac4bdf968b7b9af8a5239a27da73d5711"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator new" ref="ac4bdf968b7b9af8a5239a27da73d5711" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00072">72</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab78a921e54419be677839cdf15d1f0b8"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator new" ref="ab78a921e54419be677839cdf15d1f0b8" args="(size_t sz, void *ptr)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">void *&#160;</td>
          <td class="paramname"><em>ptr</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>placement operator new </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00078">78</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4be37baef81876985aa1071ad5acc6dd"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator new[]" ref="a4be37baef81876985aa1071ad5acc6dd" args="(size_t sz, const char *file, int line, const char *func)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>file</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">int&#160;</td>
          <td class="paramname"><em>line</em>, </td>
        </tr>
        <tr>
          <td class="paramkey"></td>
          <td></td>
          <td class="paramtype">const char *&#160;</td>
          <td class="paramname"><em>func</em>&#160;</td>
        </tr>
        <tr>
          <td></td>
          <td>)</td>
          <td></td><td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>array operator new, with debug line info </p>

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00085">85</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="afa2943846ba6a2b5824a12857139cf5e"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::operator new[]" ref="afa2943846ba6a2b5824a12857139cf5e" args="(size_t sz)" -->
<div class="memitem">
<div class="memproto">
<div class="memtemplate">
template&lt;class Alloc &gt; </div>
      <table class="memname">
        <tr>
          <td class="memname">void* <a class="el" href="classOgre_1_1AllocatedObject.html">Ogre::AllocatedObject</a>&lt; Alloc &gt;::operator new[] </td>
          <td>(</td>
          <td class="paramtype">size_t&#160;</td>
          <td class="paramname"><em>sz</em></td><td>)</td>
          <td><code> [inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreMemoryAllocatedObject_8h_source.html#l00090">90</a> of file <a class="el" href="OgreMemoryAllocatedObject_8h_source.html">OgreMemoryAllocatedObject.h</a>.</p>

</div>
</div>
<a class="anchor" id="ad96281be1b189c69a1dbd2283d583503"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::optimise" ref="ad96281be1b189c69a1dbd2283d583503" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#ad96281be1b189c69a1dbd2283d583503">Ogre::AnimationTrack::optimise</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Optimise the current track by removing any duplicate keyframes. </p>

<p>Reimplemented in <a class="el" href="classOgre_1_1VertexAnimationTrack.html#a366c0dfa30d9b59d685ff1f7622b5ba7">Ogre::VertexAnimationTrack</a>, and <a class="el" href="classOgre_1_1NodeAnimationTrack.html#abab18a48c2cf56ef09d5049fa8289ad2">Ogre::NodeAnimationTrack</a>.</p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00224">224</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="a4e61fb2e00abd26a854d122452cb21a0"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::populateClone" ref="a4e61fb2e00abd26a854d122452cb21a0" args="(AnimationTrack *clone) const " -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#a4e61fb2e00abd26a854d122452cb21a0">Ogre::AnimationTrack::populateClone</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1AnimationTrack.html">AnimationTrack</a> *&#160;</td>
          <td class="paramname"><em>clone</em></td><td>)</td>
          <td> const<code> [protected, virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Internal method for clone implementation. </p>

</div>
</div>
<a class="anchor" id="ac8f7b83d742998ed46c8cdb10e404df6"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::removeAllKeyFrames" ref="ac8f7b83d742998ed46c8cdb10e404df6" args="(void)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#ac8f7b83d742998ed46c8cdb10e404df6">Ogre::AnimationTrack::removeAllKeyFrames</a> </td>
          <td>(</td>
          <td class="paramtype">void&#160;</td>
          <td class="paramname"></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes all the KeyFrames from this track. </p>

</div>
</div>
<a class="anchor" id="a3e1ccd99179d804992a5224fe811c2dd"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::removeKeyFrame" ref="a3e1ccd99179d804992a5224fe811c2dd" args="(unsigned short index)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#a3e1ccd99179d804992a5224fe811c2dd">Ogre::AnimationTrack::removeKeyFrame</a> </td>
          <td>(</td>
          <td class="paramtype">unsigned short&#160;</td>
          <td class="paramname"><em>index</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Removes a <a class="el" href="classOgre_1_1KeyFrame.html" title="A key frame in an animation sequence defined by an AnimationTrack.">KeyFrame</a> by it's index. </p>

</div>
</div>
<a class="anchor" id="a89d5b800fa465b59a38ab08ebee07b5a"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::setAssociatedAnimable" ref="a89d5b800fa465b59a38ab08ebee07b5a" args="(const AnimableValuePtr &amp;val)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1NumericAnimationTrack.html#a89d5b800fa465b59a38ab08ebee07b5a">Ogre::NumericAnimationTrack::setAssociatedAnimable</a> </td>
          <td>(</td>
          <td class="paramtype">const <a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> &amp;&#160;</td>
          <td class="paramname"><em>val</em></td><td>)</td>
          <td><code> [virtual]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Sets the associated animable object which will be automatically affected by calls to 'apply'. </p>

</div>
</div>
<a class="anchor" id="afe26aa738aca34c07407b6566b5d9eeb"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::setListener" ref="afe26aa738aca34c07407b6566b5d9eeb" args="(Listener *l)" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">virtual void <a class="el" href="classOgre_1_1AnimationTrack.html#afe26aa738aca34c07407b6566b5d9eeb">Ogre::AnimationTrack::setListener</a> </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classOgre_1_1AnimationTrack_1_1Listener.html">Listener</a> *&#160;</td>
          <td class="paramname"><em>l</em></td><td>)</td>
          <td><code> [virtual, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Set a listener for this track. </p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00237">237</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<hr/><h2>Member Data Documentation</h2>
<a class="anchor" id="a5fb5dc3c01452aa4d542981485d15080"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mHandle" ref="a5fb5dc3c01452aa4d542981485d15080" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">unsigned short <a class="el" href="classOgre_1_1AnimationTrack.html#a5fb5dc3c01452aa4d542981485d15080">Ogre::AnimationTrack::mHandle</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00245">245</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="a2c053bac1d2eedc782eb24b79dc79a21"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mKeyFrameIndexMap" ref="a2c053bac1d2eedc782eb24b79dc79a21" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimationTrack.html#a2faf6bb4a4d61446bc25795f8f7d957c">KeyFrameIndexMap</a> <a class="el" href="classOgre_1_1AnimationTrack.html#a2c053bac1d2eedc782eb24b79dc79a21">Ogre::AnimationTrack::mKeyFrameIndexMap</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00250">250</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="a8a9bee08f6fa537fc0bcfcee2423775c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mKeyFrames" ref="a8a9bee08f6fa537fc0bcfcee2423775c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimationTrack.html#affbdca5aaf89d6d611d8da2dc6143f1a">KeyFrameList</a> <a class="el" href="classOgre_1_1AnimationTrack.html#a8a9bee08f6fa537fc0bcfcee2423775c">Ogre::AnimationTrack::mKeyFrames</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00243">243</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="ab1a098b88d428931e3d45393410bc68c"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mListener" ref="ab1a098b88d428931e3d45393410bc68c" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1AnimationTrack_1_1Listener.html">Listener</a>* <a class="el" href="classOgre_1_1AnimationTrack.html#ab1a098b88d428931e3d45393410bc68c">Ogre::AnimationTrack::mListener</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00246">246</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="aea479089005d263e195cde7e4faca665"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mParent" ref="aea479089005d263e195cde7e4faca665" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classOgre_1_1Animation.html">Animation</a>* <a class="el" href="classOgre_1_1AnimationTrack.html#aea479089005d263e195cde7e4faca665">Ogre::AnimationTrack::mParent</a><code> [protected, inherited]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00244">244</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<a class="anchor" id="a9abd089b3278141471254455f45c648d"></a><!-- doxytag: member="Ogre::NumericAnimationTrack::mTargetAnim" ref="a9abd089b3278141471254455f45c648d" args="" -->
<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="group__Animation.html#ga5e0882c3b9f7ca32a795f98cf034e428">AnimableValuePtr</a> <a class="el" href="classOgre_1_1NumericAnimationTrack.html#a9abd089b3278141471254455f45c648d">Ogre::NumericAnimationTrack::mTargetAnim</a><code> [protected]</code></td>
        </tr>
      </table>
</div>
<div class="memdoc">

<p>Target to animate. </p>

<p>Definition at line <a class="el" href="OgreAnimationTrack_8h_source.html#l00315">315</a> of file <a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a>.</p>

</div>
</div>
<hr/>The documentation for this class was generated from the following file:<ul>
<li><a class="el" href="OgreAnimationTrack_8h_source.html">OgreAnimationTrack.h</a></li>
</ul>
</div><!-- contents -->
<hr>
<p>
Copyright &copy; 2012 Torus Knot Software Ltd<br />
<!--Creative Commons License--><a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/"><img alt="Creative Commons License" style="border-width:0" src="http://i.creativecommons.org/l/by-sa/3.0/88x31.png" /></a><br />This work is licensed under a <a rel="license" href="http://creativecommons.org/licenses/by-sa/3.0/">Creative Commons Attribution-ShareAlike 3.0 Unported License</a>.<br/>
		<!--/Creative Commons License--><!-- <rdf:RDF xmlns="http://web.resource.org/cc/" xmlns:dc="http://purl.org/dc/elements/1.1/" xmlns:rdf="http://www.w3.org/1999/02/22-rdf-syntax-ns#">
		<Work rdf:about="">
			<license rdf:resource="http://creativecommons.org/licenses/by-sa/2.5/" />
	<dc:type rdf:resource="http://purl.org/dc/dcmitype/Text" />
		</Work>
		<License rdf:about="http://creativecommons.org/licenses/by-sa/2.5/"><permits rdf:resource="http://web.resource.org/cc/Reproduction"/><permits rdf:resource="http://web.resource.org/cc/Distribution"/><requires rdf:resource="http://web.resource.org/cc/Notice"/><requires rdf:resource="http://web.resource.org/cc/Attribution"/><permits rdf:resource="http://web.resource.org/cc/DerivativeWorks"/><requires rdf:resource="http://web.resource.org/cc/ShareAlike"/></License></rdf:RDF> -->

Last modified Fri May 25 2012 21:48:54
</p>
</body>
</html>
